Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing
Class JRootPane

    java.lang.Object
      |
      +--java.awt.Component
            |
            +--java.awt.Container
                  |
                  +--javax.swing.JComponent
                        |
                        +--javax.swing.JRootPane

public class JRootPane
extends JComponent
implements Accessible

The fundamental component in the container hierarchy. In the same way that JComponent is fundamental to the JFC/Swing components, JRootPane is fundamental to the JFC/Swing window, frame, and pane containers. However, while other classes use inheritance to take advantage of JComponent's capabilities, the container classes delegate operations to a JRootPane instance. Those containers are the heavyweight containers: JFrame, JDialog, JWindow, and JApplet, as well as the lightweight container, JInternalFrame.

The following image shows these relationships:

The "heavyweight" components (those that delegate to a peer, or native component on the host system) are shown with a darker, heavier box. The four heavyweight JFC/Swing containers (JFrame, JDialog, JWindow, and JApplet) are shown in relation to the AWT classes they extend. These four components are the only heavyweight containers in the Swing library. The lightweight container, JInternalPane, is also shown. All 5 of these JFC/Swing containers implement the RootPaneContainer interface, and they all delegate their operations to a JRootPane (shown with a little "handle" on top).

> Note: The JComponent method `getRootPane` can be used to obtain the JRootPane that contains a given component.

The diagram at right shows the structure of a JRootPane. A JRootpane is made up of a glassPane, an optional menuBar, and a contentPane. (The JLayeredPane manages the menuBar and the contentPane.) The glassPane sits over the top of everything, where it is in a position to intercept mouse movements. Since the glassPane (like the contentPane) can be an arbitrary component, it is also possible to set up the glassPane for drawing. Lines and images on the glassPane can then range over the frames underneath without being limited by their boundaries.

Although the menuBar component is optional, the layeredPane, contentPane, and glassPane always exist. Attempting to set them to null generates an exception.

The `contentPane` must be the parent of any children of the JRootPane. Rather than adding directly to a JRootPane, like this:

           rootPane.add(child);

You instead add to the contentPane of the JRootPane, like this:

           rootPane.getContentPane().add(child);

The same priniciple holds true for setting layout managers, removing components, listing children, etc. All these methods are invoked on the `contentPane` instead of on the JRootPane.

> Note: The default layout manager for the `contentPane` is a BorderLayout manager. However, the JRootPane uses a custom LayoutManager. So, when you want to change the layout manager for the components you added to a JRootPane, be sure to use code like this:

>         rootPane.getContentPane().setLayout(new BoxLayout());

If a JMenuBar component is set on the JRootPane, it is positioned along the upper edge of the frame. The `contentPane` is adjusted in location and size to fill the remaining area. (The JMenuBar and the `contentPane` are added to the `layeredPane` component at the JLayeredPane.FRAME_CONTENT_LAYER layer.)

The `layeredPane` is the parent of all children in the JRootPane. It is an instance of JLayeredPane, which provides the ability to add components at several layers. This capability is very useful when working with menu popups, dialog boxes, and dragging -- situations in which you need to place a component on top of all other components in the pane.

The `glassPane` sits on top of all other components in the JRootPane. That provides a convenient place to draw above all other components, and makes it possible to intercept mouse events, which is useful both for dragging and for drawing. Developers can use `setVisible` on the glassPane to control when the `glassPane` displays over the other children. By default the `glassPane` is not visible.

The custom LayoutManager used by JRootPane ensures that:

1. The `glassPane`, if present, fills the entire viewable area of the JRootPane (bounds - insets).
2. The `layeredPane` fills the entire viewable area of the JRootPane. (bounds - insets)
3. The `menuBar` is positioned at the upper edge of the layeredPane().
4. The `contentPane` fills the entire viewable area, minus the MenuBar, if present.

Any other views in the JRootPane view hierarchy are ignored.

If you replace the LayoutManager of the JRootPane, you are responsible for managing all of these views. So ordinarily you will want to be sure that you change the layout manager for the `contentPane` rather than for the JRootPane itself!

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. A future release of Swing will provide support for long term persistence.

See Also:
  `JLayeredPane`, `JMenuBar`, `JWindow`, `JFrame`, `JDialog`, `JApplet`, `JInternalFrame`, `JComponent`, `BoxLayout`, Mixing Heavy and Light Components, Serialized Form

Inner Class Summary
`protected class` | `JRootPane.AccessibleJRootPane` The class used to obtain the accessible role for this object.
`protected class` | `JRootPane.RootLayout` A custom layout manager that is responsible for the layout of layeredPane, glassPane, and menuBar.

Inner classes inherited from class javax.swing.JComponent
`JComponent.AccessibleJComponent`

Field Summary
`protected java.awt.Container` | `contentPane` The content pane.
`protected JButton` | `defaultButton` The button that gets activated when the pane has the focus and a UI-specific action like pressing the Enter key occurs.
`protected javax.swing.JRootPane.DefaultAction` | `defaultPressAction` The action to take when the defaultButton is pressed.
`protected javax.swing.JRootPane.DefaultAction` | `defaultReleaseAction` The action to take when the defaultButton is released.
`protected java.awt.Component` | `glassPane` The glass pane that overlays the menu bar and content pane, so it can intercept mouse movements and such.
`protected JLayeredPane` | `layeredPane` The layered pane that manages the menu bar and content pane.
`protected JMenuBar` | `menuBar` The menu bar.

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Constructor Summary
`JRootPane()` Create a JRootPane, setting up its glassPane, LayeredPane, and contentPane.

Method Summary
`protected void` | `addImpl(java.awt.Component comp, java.lang.Object constraints, int index)` Overridden to enforce the position of the glass component as the zero child.
`void` | `addNotify()` Register ourselves with the SystemEventQueueUtils as a new root pane.
`protected java.awt.Container` | `createContentPane()` Called by the constructor methods to create the default contentPane.
`protected java.awt.Component` | `createGlassPane()` Called by the constructor methods to create the default glassPane.
`protected JLayeredPane` | `createLayeredPane()` Called by the constructor methods to create the default layeredPane.
`protected java.awt.LayoutManager` | `createRootLayout()` Called by the constructor methods to create the default layoutManager.
`AccessibleContext` | `getAccessibleContext()` Get the AccessibleContext associated with this JComponent
`java.awt.Container` | `getContentPane()` Returns the content pane -- the container that holds the components parented by the root pane.
`JButton` | `getDefaultButton()` Returns the current default button for this JRootPane.
`java.awt.Component` | `getGlassPane()` Returns the current glass pane for this JRootPane.
`JMenuBar` | `getJMenuBar()` Returns the menu bar from the layered pane.
`JLayeredPane` | `getLayeredPane()` Get the layered pane used by the root pane.
`JMenuBar` | `getMenuBar()` Deprecated. As of Swing version 1.0.3 replaced by `getJMenubar()`.
`boolean` | `isFocusCycleRoot()` Make JRootPane be the root of a focus cycle.
`boolean` | `isValidateRoot()` If a descendant of this JRootPane calls revalidate, validate from here on down.
`protected java.lang.String` | `paramString()` Returns a string representation of this JRootPane.
`void` | `removeNotify()` Unregister ourselves from SystemEventQueueUtils.
`void` | `setContentPane(java.awt.Container content)` Sets the content pane -- the container that holds the components parented by the root pane.
`void` | `setDefaultButton(JButton defaultButton)` Sets the current default button for this JRootPane.
`void` | `setGlassPane(java.awt.Component glass)` Sets a specified Component to be the glass pane for this root pane.
`void` | `setJMenuBar(JMenuBar menu)` Adds or changes the menu bar used in the layered pane.
`void` | `setLayeredPane(JLayeredPane layered)` Set the layered pane for the root pane.
`void` | `setMenuBar(JMenuBar menu)` Deprecated. As of Swing version 1.0.3 replaced by `setJMenuBar(JMenuBar menu)`.

Methods inherited from class javax.swing.JComponent
`addAncestorListener, addPropertyChangeListener, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getAlignmentX, getAlignmentY, getAutoscrolls, getBorder, getBounds, getClientProperty, getComponentGraphics, getConditionForKeyStroke, getDebugGraphicsOptions, getGraphics, getHeight, getInsets, getInsets, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getUIClassID, getVisibleRect, getWidth, getX, getY, grabFocus, hasFocus, isDoubleBuffered, isFocusTraversable, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingTile, isRequestFocusEnabled, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, processComponentKeyEvent, processFocusEvent, processKeyEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removePropertyChangeListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setDebugGraphicsOptions, setDoubleBuffered, setEnabled, setFont, setForeground, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setUI, setVisible, unregisterKeyboardAction, update, updateUI`

Methods inherited from class java.awt.Container
`add, add, add, add, add, addContainerListener, countComponents, deliverEvent, doLayout, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getLayout, insets, invalidate, isAncestorOf, layout, list, list, locate, minimumSize, paintComponents, preferredSize, print, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setLayout, validate, validateTree`

Methods inherited from class java.awt.Component
`action, add, addComponentListener, addFocusListener, addKeyListener, addMouseListener, addMouseMotionListener, bounds, checkImage, checkImage, contains, createImage, createImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, getBackground, getBounds, getColorModel, getCursor, getFont, getFontMetrics, getForeground, getLocale, getLocation, getLocationOnScreen, getName, getParent, getPeer, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hide, imageUpdate, inside, isEnabled, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, printAll, processComponentEvent, processMouseEvent, remove, removeComponentListener, removeFocusListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setCursor, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### menuBar

    protected JMenuBar menuBar

  The menu bar.

### contentPane

    protected java.awt.Container contentPane

  The content pane.

### layeredPane

    protected JLayeredPane layeredPane

  The layered pane that manages the menu bar and content pane.

### glassPane

    protected java.awt.Component glassPane

  The glass pane that overlays the menu bar and content pane, so it can intercept mouse movements and such.

### defaultButton

    protected JButton defaultButton

  The button that gets activated when the pane has the focus and a UI-specific action like pressing the Enter key occurs.

### defaultPressAction

    protected javax.swing.JRootPane.DefaultAction defaultPressAction

  The action to take when the defaultButton is pressed.
  See Also:
    `defaultButton`

### defaultReleaseAction

    protected javax.swing.JRootPane.DefaultAction defaultReleaseAction

  The action to take when the defaultButton is released.
  See Also:
    `defaultButton`

Constructor Detail

### JRootPane

    public JRootPane()

  Create a JRootPane, setting up its glassPane, LayeredPane, and contentPane.

Method Detail

### createLayeredPane

    protected JLayeredPane createLayeredPane()

  Called by the constructor methods to create the default layeredPane. Bt default it creates a new JLayeredPane.

### createContentPane

    protected java.awt.Container createContentPane()

  Called by the constructor methods to create the default contentPane. By default this method creates a new JComponent add sets a BorderLayout as its LayoutManager.

### createGlassPane

    protected java.awt.Component createGlassPane()

  Called by the constructor methods to create the default glassPane. By default this method creates a new JComponent with visibility set to false.

### createRootLayout

    protected java.awt.LayoutManager createRootLayout()

  Called by the constructor methods to create the default layoutManager.

### setJMenuBar

    public void setJMenuBar(JMenuBar menu)

  Adds or changes the menu bar used in the layered pane.
  Parameters:
    `menu` - the JMenuBar to add

### setMenuBar

    public void setMenuBar(JMenuBar menu)

  Deprecated. As of Swing version 1.0.3 replaced by `setJMenuBar(JMenuBar menu)`.
  Specifies the menu bar value.

### getJMenuBar

    public JMenuBar getJMenuBar()

  Returns the menu bar from the layered pane.
  Returns:
    the JMenuBar used in the pane

### getMenuBar

    public JMenuBar getMenuBar()

  Deprecated. As of Swing version 1.0.3 replaced by `getJMenubar()`.
  Returns the menu bar value.

### setContentPane

    public void setContentPane(java.awt.Container content)

  Sets the content pane -- the container that holds the components parented by the root pane.
  Parameters:
    `content` - the Container to use for component-contents
  Throws:
    java.awt.IllegalComponentStateException - (a runtime exception) if the content pane parameter is null

### getContentPane

    public java.awt.Container getContentPane()

  Returns the content pane -- the container that holds the components parented by the root pane.
  Returns:
    the Container that holds the component-contents

### setLayeredPane

    public void setLayeredPane(JLayeredPane layered)

  Set the layered pane for the root pane. The layered pane typically holds a content pane and an optional JMenuBar.
  Parameters:
    `layered` - the JLayeredPane to use.
  Throws:
    java.awt.IllegalComponentStateException - (a runtime exception) if the layered pane parameter is null

### getLayeredPane

    public JLayeredPane getLayeredPane()

  Get the layered pane used by the root pane. The layered pane typically holds a content pane and an optional JMenuBar.
  Returns:
    the JLayeredPane currently in use

### setGlassPane

    public void setGlassPane(java.awt.Component glass)

  Sets a specified Component to be the glass pane for this root pane. The glass pane should normally be a lightweight, transparent component, because it will be made visible when ever the root pane needs to grab input events. For example, only one JInternalFrame is ever active when using a DefaultDesktop, and any inactive JInternalFrames' glass panes are made visible so that clicking anywhere within an inactive JInternalFrame can activate it.
  Parameters:
    `glass` - the Component to use as the glass pane for this JRootPane.

### getGlassPane

    public java.awt.Component getGlassPane()

  Returns the current glass pane for this JRootPane.
  Returns:
    the current glass pane.
  See Also:
    `setGlassPane(java.awt.Component)`

### isFocusCycleRoot

    public boolean isFocusCycleRoot()

  Make JRootPane be the root of a focus cycle. That means that, by default, tabbing within the root pane will move between components of the pane, but not out of the pane.
  Returns:
    true
  Overrides:
    isFocusCycleRoot in class JComponent
  See Also:
    `JComponent.isFocusCycleRoot()`

### isValidateRoot

    public boolean isValidateRoot()

  If a descendant of this JRootPane calls revalidate, validate from here on down.

  Deferred requests to relayout a component and it's descendants, i.e. calls to revalidate(), are pushed upwards to either a JRootPane or a JScrollPane because both classes override isValidateRoot() to return true.

  Returns:
    true
  Overrides:
    isValidateRoot in class JComponent
  See Also:
    `JComponent.isValidateRoot()`

### addNotify

    public void addNotify()

  Register ourselves with the SystemEventQueueUtils as a new root pane.
  Overrides:
    addNotify in class JComponent

### removeNotify

    public void removeNotify()

  Unregister ourselves from SystemEventQueueUtils.
  Overrides:
    removeNotify in class JComponent

### setDefaultButton

    public void setDefaultButton(JButton defaultButton)

  Sets the current default button for this JRootPane. The default button is the button which will be activated when a UI-defined activation event (typically the Enter key) occurs in the RootPane regardless of whether or not the button has keyboard focus (unless there is another component within the RootPane which consumes the activation event, such as a JTextPane). For default activation to work, the button must be an enabled descendent of the RootPane when activation occurs. To remove a default button from this RootPane, set this property to null.
  Parameters:
    `default` - the JButton which is to be the default button
  See Also:
    `JButton.isDefaultButton()`

### getDefaultButton

    public JButton getDefaultButton()

  Returns the current default button for this JRootPane.
  Returns:
    the JButton which is currently the default button

### addImpl

    protected void addImpl(java.awt.Component comp,
                           java.lang.Object constraints,
                           int index)

  Overridden to enforce the position of the glass component as the zero child.
  Overrides:
    addImpl in class java.awt.Container

### paramString

    protected java.lang.String paramString()

  Returns a string representation of this JRootPane. This method is intended to be used only for debugging purposes, and the content and format of the returned string may vary between implementations. The returned string may be empty but may not be `null`.

  Overriding paramString() to provide information about the specific new aspects of the JFC components.

  Returns:
    a string representation of this JRootPane.
  Overrides:
    paramString in class JComponent

### getAccessibleContext

    public AccessibleContext getAccessibleContext()

  Get the AccessibleContext associated with this JComponent
  Specified by:
    getAccessibleContext in interface Accessible
  Returns:
    the AccessibleContext of this JComponent
  Overrides:
    getAccessibleContext in class JComponent

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-1998 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.